<?php
App::uses('EvAddressBookAppModel', 'EvAddressBook.Model');
/**
 * Address Model
 *
 * @property Country $Country
 */
class Address extends EvAddressBookAppModel {

/**
 * Display field
 *
 * @var string
 */
	public $displayField = 'name';

/**
 * Validation rules
 *
 * @var array
 */
	public $validate = array(
		'model' => array(
			'notBlank' => array(
				'rule' => array('notBlank'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
		'model_id' => array(
			'notBlank' => array(
				'rule' => array('notBlank'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
		'address1' => array(
			'notBlank' => array(
				'rule' => array('notBlank'),
				'message' => 'Please fill out address line 1'
			),
		),
		'city' => array(
			'notBlank' => array(
				'rule' => array('notBlank'),
				'message' => 'Please fill out the city'
			),
		),
		'county' => array(
			'notBlank' => array(
				'rule' => array('notBlank'),
				'message' => 'please fill out the county'
			),
		),
		'post_code' => array(
			'notBlank' => array(
				'rule' => array('notBlank'),
				'message' => 'Please fill out the postcode'
			),
		),
	);

	//The Associations below have been created with all possible keys, those that are not needed can be removed

/**
 * belongsTo associations
 *
 * @var array
 */
	public $belongsTo = array(
		'Country' => array(
			'className' => 'EvCountry.Country'
		)
	);

	/**
	 * get all the address for a given model / model id
	 *
	 * @param 	string 	$model  	The model the data belongs to
	 * @param 	int 	$modelId 	The id the address relates to
	 * @return 	array
	 */
	public function getAddresses($model, $modelId) {
		return $this->find(
			'all',
			array(
				'conditions' => array(
					'Address.model' => $model,
					'Address.model_id' => $modelId
				),
				'contain' => array(
					'Country'
				)
			)
		);
	}
}
